/*
 *   
 * A Simple accounting system
 *
 * Copyright 2006 Alexander S.Kresin <alex@belacy.belgorod.su>
 * www - http://kresin.belgorod.su
*/

#include "windows.ch"
#include "guilib.ch"
#include "dbstruct.ch"
#include "hbclass.ch"
#include "hxml.ch"

#define  DO_ADDREC    1
#define  DO_EDITREC   2
#define  DO_FINDREC   3
#define  DO_FILTREC   4

REQUEST ACOPY

REQUEST DBSEEK
REQUEST DBCREATEINDEX
REQUEST DBSETFILTER
REQUEST DBCLEARFILTER
REQUEST ORDKEYCOUNT
REQUEST ORDKEYNO
REQUEST ORDKEYVAL
REQUEST __DBAPP
REQUEST __DBPACK
REQUEST __DBCOPY
REQUEST DBCREATE
REQUEST DBEVAL
REQUEST HB_ATOKENS
#ifndef __LINUX__
REQUEST HWG_SHELLEXECUTE
#endif
REQUEST HWG_MSGYESNO
REQUEST HB_CODEPAGE_RU866
REQUEST HB_CODEPAGE_RU1251
REQUEST HB_CODEPAGE_RUKOI8
REQUEST HB_LANG_RUWIN
REQUEST HB_LANG_RUKOI8

#ifdef RDD_LETO
REQUEST LETO_GETCURRENTCONNECTION
REQUEST LETO_CONNECT
#endif

REQUEST HB_HASH

#ifdef __LINUX__
ANNOUNCE HB_GTSYS
REQUEST HB_GT_CGI_DEFAULT
#else
ANNOUNCE HB_GTSYS
REQUEST HB_GT_GUI_DEFAULT
#endif

Memvar wright, oApp, aTxt_Menu, aTxt_Btn, aTxt_Msg

FUNCTION Main( cIniName )
Public oApp
Public aTxt_Menu := { "&","&","&","&","&", ;
 "&","&","  ","&","&","&","& ","&","","" }
Public aTxt_Btn := { "","","","","","", ;
 "","","","" }
Public aTxt_Msg := { "    ", "    ", ;
 " ","  -  "," ", ;
 "", "   !","   ", ;
 "", "!"," ",": "," ","   !", ;
 " ","","   !","   !", ;
 "   !","  ","   ", ;
 "   ","   ","  ", ;
 "", " " }
Private vtmp1

   oApp := HApp():New()

#ifdef RDD_ADS
   #include "ads.ch"
   REQUEST ADS
   rddRegister("ADS",1)
   rddSetdefault("ADS")
   adsrightscheck( .F. )
#endif
#ifdef RDD_LETO
   REQUEST LETO
   RDDSETDEFAULT( "LETO" )
#endif
#ifdef RDD_CDX
   REQUEST DBFCDX
   rddRegister("DBFCDX",1)
   rddSetdefault("DBFCDX")
   SET AUTOPEN ON
#endif

#ifdef __LINUX__
   hwg_SetAppLocale( "WINDOWS-1251" )
#endif
   oApp:cp := "RU1251"
   hb_langSelect( "RUWIN" )
   hb_cdpSelect( oApp:cp )

   SET EPOCH TO 1960
   SET DATE BRITISH
   SET EXCLUSIVE OFF
   SET DELETED ON
   ReadExit( .T. )

   InitPrg( Iif( cIniName == Nil, "general.ini", cIniName ) )

   IF !ReadOptions()
      hwg_Msgstop( aTxt_Msg[1]+oApp:optPath+oApp:optName, oApp:cTitle )
      QUIT
   ENDIF
   IF Empty( HData():aTables )
      hwg_Msgstop( aTxt_Msg[2]+oApp:optPath+oApp:optName, oApp:cTitle )
      QUIT
   ENDIF

   IF !PAROL()
      QUIT
   ENDIF
#ifndef NO_PASS
   FileAccess()
#endif
   // hwg_Writelog( m->compName + ": Login " + Dtoc(Date()) + " " + Time(),"general.log" )

   SetWindow()

   IF Len( HSubsys():aSubs ) == 1
      HSubsys():aSubs[1]:Run()
   ELSE
      SetEnable( .F. )
   ENDIF

   ACTIVATE WINDOW oApp:oMainWnd

   CLOSE ALL
   // hwg_Writelog( m->compName + ": Logout " + Dtoc(Date()) + " " + Time(),"general.log" )

Return Nil

Static Function SetWindow
Local i

   INIT WINDOW oApp:oMainWnd MAIN TITLE oApp:cTitle COLOR COLOR_3DLIGHT+1 ;
     AT 0,0 SIZE 800,400

   MENU OF oApp:oMainWnd
      MENU TITLE aTxt_Menu[1]
         FOR i := 1 TO Len( HSubsys():aSubs )
            IF HSubsys():aSubs[i]:lMenuSep
               Hwg_DefineMenuItem()
            ENDIF         
            Hwg_DefineMenuItem( HSubsys():aSubs[i]:cTitle, 31020+i, &( "{||HSubsys():aSubs["+LTrim(Str(i,2))+"]:Run()}" ),,,,,,.T. )
         NEXT
         SEPARATOR
         MENUITEM aTxt_Menu[2] ACTION hwg_EndWindow()
      ENDMENU
      MENU TITLE aTxt_Menu[3] ID 31010
         MENUITEM aTxt_Menu[4]+Chr(9)+"F3" ID 31011 ACTION oApp:oDataMain:EdDoc( DO_ADDREC ) ;
            ACCELERATOR 0,VK_F3
         MENUITEM aTxt_Menu[5]+Chr(9)+"F4" ACTION oApp:oDataMain:EdDoc( DO_EDITREC ) ;
            ACCELERATOR 0,VK_F4
         MENUITEM aTxt_Menu[6]+Chr(9)+"F5" ACTION oApp:oDataMain:EdDoc( DO_FINDREC ) ;
            ACCELERATOR 0,VK_F5
         MENUITEM aTxt_Menu[7]+Chr(9)+"F6" ACTION oApp:oDataMain:EdDoc( DO_FILTREC ) ;
            ACCELERATOR 0,VK_F6
         MENUITEM aTxt_Menu[8]+Chr(9)+"Ctrl+F6" ACTION FltShb(oApp:oDataMain) ;
            ACCELERATOR FCONTROL,VK_F6
         SEPARATOR
         MENUITEM aTxt_Menu[9]+Chr(9)+"F8" ACTION oApp:oDataMain:DelDoc() ;
            ACCELERATOR 0,VK_F8
      ENDMENU
      MENU TITLE aTxt_Menu[10]
      ENDMENU
      MENU TITLE aTxt_Menu[13]
         MENUITEM aTxt_Menu[14] ACTION ChangeFont( oApp:oBrw, 2 ) ACCELERATOR FCONTROL,VK_ADD
         MENUITEM aTxt_Menu[15] ACTION ChangeFont( oApp:oBrw, -2 ) ACCELERATOR FCONTROL,VK_SUBTRACT
      ENDMENU
      MENU TITLE aTxt_Menu[11]
         MENUITEM aTxt_Menu[12] ACTION About()
      ENDMENU
   ENDMENU

#ifndef __LINUX__
   ADD STATUS PARTS 0,0,0
#endif

Return Nil

Static Function SetToolBar
LOCAL oSubs, oBtn, oFontBtn, x := 2, nWidth := 70, nHeight := 40, i

   IF oApp:oPanel != Nil
      oApp:oMainWnd:DelControl( oApp:oPanel )
   ENDIF

   PREPARE FONT oFontBtn NAME "MS Sans Serif" WIDTH 0 HEIGHT -12

   oSubs := oApp:oSubs

   @ 0,0 PANEL oApp:oPanel OF oApp:oMainWnd SIZE oApp:oMainWnd:nWidth-2,nHeight+4

   IF oSubs:aToolMask == Nil .OR. oSubs:aToolMask[1] == "1"
      @ x,3 OWNERBUTTON OF oApp:oPanel                         ;
           ON CLICK {||oApp:oBrw:Top()}                        ;
           SIZE nWidth,nHeight FLAT                            ;
           TEXT aTxt_Btn[1] FONT oFontBtn COORDINATES 0,20,0,0 ;
           BITMAP "top.bmp" COORDINATES 0,4,0,0 TRANSPARENT COLOR 12632256
      x += nWidth
   ENDIF
   IF oSubs:aToolMask == Nil .OR. oSubs:aToolMask[2] == "1"
      @ x,3 OWNERBUTTON OF oApp:oPanel                         ;
           ON CLICK {||oApp:oBrw:Bottom()}                     ;
           SIZE nWidth,nHeight FLAT                            ;
           TEXT aTxt_Btn[2] FONT oFontBtn COORDINATES 0,20,0,0 ;
           BITMAP "bottom.bmp" COORDINATES 0,4,0,0 TRANSPARENT COLOR 12632256
      x += nWidth
   ENDIF
   IF oSubs:aToolMask == Nil .OR. oSubs:aToolMask[3] == "1"
      @ x,3 OWNERBUTTON oBtn OF oApp:oPanel                    ;
           ON CLICK {||oApp:oDataMain:EdDoc( DO_ADDREC )}      ;
           SIZE nWidth,nHeight FLAT                            ;
           TEXT aTxt_Btn[3] FONT oFontBtn COORDINATES 0,20,0,0 ;
           BITMAP "add.bmp" COORDINATES 0,4,0,0 TRANSPARENT COLOR 12632256
      oBtn:cargo := 1
      x += nWidth
   ENDIF
   IF oSubs:aToolMask == Nil .OR. oSubs:aToolMask[4] == "1"
      @ x,3 OWNERBUTTON OF oApp:oPanel                         ;
           ON CLICK {||oApp:oDataMain:EdDoc( DO_EDITREC )}     ;
           SIZE nWidth,nHeight FLAT                            ;
           TEXT aTxt_Btn[4] FONT oFontBtn COORDINATES 0,20,0,0 ;
           BITMAP "edit.bmp" COORDINATES 0,4,0,0 TRANSPARENT COLOR 12632256
      x += nWidth
   ENDIF

   x += 2
   @ x,5 LINE OF oApp:oPanel LENGTH 36 VERTICAL
   x += 3

   IF oSubs:aToolMask == Nil .OR. oSubs:aToolMask[5] == "1"
      @ x,3 OWNERBUTTON OF oApp:oPanel                         ;
           ON CLICK {||oApp:oDataMain:EdDoc( DO_FINDREC )}     ;
           SIZE nWidth,nHeight FLAT                            ;
           TEXT aTxt_Btn[5] FONT oFontBtn COORDINATES 0,20,0,0 ;
           BITMAP "find.bmp" COORDINATES 0,4,0,0 TRANSPARENT COLOR 12632256
      x += nWidth
   ENDIF
   IF oSubs:aToolMask == Nil .OR. oSubs:aToolMask[6] == "1"
      @ x,3 OWNERBUTTON OF oApp:oPanel                         ;
           ON CLICK {||oApp:oDataMain:EdDoc( DO_FILTREC )}     ;
           SIZE nWidth,nHeight FLAT                            ;
           TEXT aTxt_Btn[6] FONT oFontBtn COORDINATES 0,20,0,0 ;
           BITMAP "filter.bmp" COORDINATES 0,4,0,0 TRANSPARENT COLOR 12632256
      x += nWidth
   ENDIF

   x += 2
   @ x,5 LINE OF oApp:oPanel LENGTH 36 VERTICAL
   x += 3

   IF oSubs:aToolMask == Nil .OR. oSubs:aToolMask[7] == "1"
      @ x,3 OWNERBUTTON OF oApp:oPanel                         ;
           ON CLICK {||oApp:oDataMain:Print( oApp:cPrinter,oApp:lPreview,.T. )} ;
           SIZE nWidth,nHeight FLAT                            ;
           TEXT aTxt_Btn[7] FONT oFontBtn COORDINATES 0,22,0,0 ;
           BITMAP "print.bmp" COORDINATES 0,4,0,0 TRANSPARENT COLOR 12632256
      x += nWidth
   ENDIF

   x += 2
   @ x,5 LINE OF oApp:oPanel LENGTH 36 VERTICAL
   x += 3

   FOR i := 1 TO Len( oSubs:aToolBtn )
      @ x,3 OWNERBUTTON OF oApp:oPanel ;
           ON CLICK &( "{||oApp:oSubs:aToolBtn["+Ltrim(Str(i))+",4]:Run()}" ) ;
           SIZE nWidth,nHeight FLAT ;          
           TEXT oSubs:aToolBtn[i,1] FONT oFontBtn COORDINATES 0,22,0,0 ;
           BITMAP Iif(oSubs:aToolBtn[i,2]==Nil,Nil,oSubs:aToolBtn[i,2]) COORDINATES 0,4,0,0 ;
           TRANSPARENT COLOR Iif(oSubs:aToolBtn[i,3]==Nil,12632256,Val(oSubs:aToolBtn[i,3]) )
      x += nWidth
   NEXT

   x += 2
   @ x,5 LINE OF oApp:oPanel LENGTH 36 VERTICAL
   x += 3

   IF oSubs:aToolMask == Nil .OR. oSubs:aToolMask[8] == "1"
      @ x,3 OWNERBUTTON OF oApp:oPanel                         ;
           ON CLICK {||hwg_EndWindow()}                            ;
           SIZE nWidth,nHeight FLAT                            ;
           TEXT aTxt_Btn[8] FONT oFontBtn COORDINATES 0,22,0,0 ;
           BITMAP "exit.bmp" COORDINATES 0,4,0,0 TRANSPARENT COLOR 12632256
   ENDIF
   oApp:oPanel:Move( ,,oApp:oPanel:nWidth+2 )
Return Nil

Static Function SetEnable( lEnable )
Local i, nLen

   IF oApp:oPanel != Nil
      nLen := Len( oApp:oPanel:aControls )
      FOR i := 1 TO nLen-1
         IF lEnable
            IF oApp:oPanel:aControls[i]:cargo == Nil .OR. ;
                      ( oApp:oDataMain:lWright )
               oApp:oPanel:aControls[i]:Enable()
            ELSE
               oApp:oPanel:aControls[i]:Disable()
            ENDIF
         ELSE
            oApp:oPanel:aControls[i]:Disable()
         ENDIF
      NEXT
   ENDIF
   IF lEnable
      hwg_Enablemenuitem( ,1, .T., .F. )
      hwg_Enablemenuitem( ,31011, oApp:oDataMain:lWright )
#ifndef __LINUX__
      hwg_Drawmenubar( oApp:oMainWnd:handle )
#endif
   ELSE
      hwg_Enablemenuitem( ,1, .F., .F. )
   ENDIF
   IF !wright .OR. ( oApp:oDataMain != Nil .AND. !oApp:oDataMain:lWright )
#ifndef __LINUX__
       hwg_WriteStatus( oApp:oMainWnd, 3 ,aTxt_Msg[3])
#endif
   ENDIF

Return Nil

Static Function InitPrg( cIniFile )
Local cSep
Memvar optpath, opttype, optfname, imgpath, cTitle, bClr, tClr, bClrSel, tClrSel
Memvar cPrinter, lPreview, strAbout1, strAbout2, cLngFile
Private cPrinter, lPreview := .T.
Private optpath := "", opttype := 0, optfname := "general.xml", imgpath
Private datalias, cDefDriver, cTitle := "", cDbLog
Private lAdsRemote := .F., laxslock := .T., cConnect
Private bClr, tClr, bClrSel, tClrSel, strAbout1 := "", strAbout2 := ""
Private cLngFile

   IF RDINI( cIniFile ) == 0
      hwg_Msginfo( "Can't found "+cIniFile, oApp:cTitle )
   ENDIF

   cSep := Set( _SET_DIRSEPARATOR )
   IF !Empty(optpath) .AND. Right( optpath,1 ) != cSep
      optpath += cSep
   ENDIF
   IF imgpath != Nil .AND. Right( imgpath,1 ) != cSep
      imgpath += cSep
   ENDIF

   oApp:cPrinter := cPrinter
   oApp:lPreview := lPreview
   oApp:optPath  := optpath
   oApp:optType  := opttype
   oApp:optName  := optfname
   oApp:imgpath  := Iif( imgpath==Nil, optpath, imgpath )
   oApp:datalias  := datalias
   oApp:cDefDriver:= cDefDriver
   oApp:cDbLog   := cDbLog
   oApp:cTitle   := cTitle
   oApp:bClr     := bClr
   oApp:tClr     := tClr
   oApp:bClrSel  := bClrSel
   oApp:tClrSel  := tClrSel
   oApp:cAbout1  := strAbout1
   oApp:cAbout2  := strAbout2
   IF cLngFile != Nil
      RDINI( cLngFile )
   ENDIF
   HOwnButton():cPath := oApp:imgpath

#ifdef RDD_ADS
   IF lAdsRemote
      adsSetServerType( 6 )
   ELSE
      SET SERVER LOCAL
   ENDIF
   IF laxslock
      SET AXS LOCKING ON
   ELSE
      SET AXS LOCKING OFF
   ENDIF
   #ifdef __LINUX__
   IF cConnect != Nil
      oApp:cConnect := cConnect
   ENDIF
   adsSetConvert(.T.)
   #endif
#endif

   IF oApp:cDefDriver != Nil
      rddSetdefault( oApp:cDefDriver )
   ENDIF

Return Nil

Static Function ReadBtnInfo( oNode )
Local aBtn := Array(4)

   aBtn[1] := oNode:GetAttribute("title")
   aBtn[2] := oNode:GetAttribute("bitmap")
   aBtn[3] := oNode:GetAttribute("trcolor")
   aBtn[4] := HScript():New( oNode )

Return aBtn

Static Function ReadTbInfo( oNode, cp )
Local oDataParent, oDataTable, oNodeF, oNodeC, cName, cAlias, cType
Local j, j1, xValue, ext_id

   cName  := Lower( oNode:GetAttribute( "name" ) )
   ext_id := oNode:GetAttribute( "ext_id" )
   cAlias := oNode:GetAttribute( "alias" )
   IF ext_id != Nil
      IF ( j := Ascan( HData():aTables, {|o|o:cName==cName.and.o:ext_id==ext_id} ) ) > 0
         oDataParent := HData():aTables[j]
      ENDIF
   ELSEIF cAlias != Nil
      cAlias := Upper( cAlias )
      IF ( j := Ascan( HData():aTables, {|o|o:cName==cName.and.o:cAlias==cAlias} ) ) > 0
         oDataParent := HData():aTables[j]
      ENDIF
   ELSE
      IF ( j := Ascan( HData():aTables, {|o|o:cName==cName} ) ) > 0
         oDataParent := HData():aTables[j]
      ENDIF
   ENDIF

   oDataTable := HData():New()
   FOR j := 1 TO Len( oNode:aItems )
      oNodeF := oNode:aItems[j]
      IF oNodeF:title == "columns"
         oDataTable:aColumns := {}
         FOR j1 := 1 TO Len( oNodeF:aItems )
            oNodeC := oNodeF:aItems[j1]
            xValue := Iif( Empty(cp).OR.cp==oApp:cp,oNodeC:GetAttribute( "title" ), ;
                          hb_Translate( oNodeC:GetAttribute( "title" ),cp,oApp:cp ) )
            IF ( cType := oNodeC:GetAttribute("type") ) != Nil
               IF ! ( cType $ "NCDLMncdlm" )
                 hwg_Msgstop( cName+"Col"+Ltrim(Str(j1))+": "+aTxt_Msg[24], oApp:cTitle )
                 cType := Nil
               ENDIF
            ENDIF
            Aadd( oDataTable:aColumns, { &(oNodeC:GetAttribute("code")), ;
                              xValue,   ;
                              cType,    ;
                              oNodeC:GetAttribute("length"), ;
                              oNodeC:GetAttribute("dec"), ;
                              oNodeC:GetAttribute("align") } )
         NEXT
      ELSEIF oNodeF:title == "index"
         oDataTable:ActiveTag := oNodeF:GetAttribute( "tag" )
      ELSEIF oNodeF:title == "print_item"
         IF Empty( oNodeF:aItems )
            oDataTable:xPrnItem := oNodeF:GetAttribute( "name" )
         ELSE
            IF oNodeF:aItems[1]:title == "script"
               oDataTable:xPrnItem := HScript():New( oNodeF:aItems[1] )
            ELSE
               oDataTable:aPrnItem := Array( Len( oNodeF:aItems ) )
               FOR j1 := 1 TO Len( oNodeF:aItems )
                  xValue := oNodeF:aItems[j1]:GetAttribute( "title" )
                  IF Empty( xValue )
                     xValue := oNodeF:aItems[j1]:GetAttribute( "name" )
                  ENDIF
                  IF !Empty(oNodeF:aItems[j1]:aItems) .AND. oNodeF:aItems[j1]:aItems[1]:title == "script"
                     oDataTable:aPrnItem[j1] := { xValue,HScript():New( oNodeF:aItems[j1]:aItems[1] ) }
                  ELSE
                     oDataTable:aPrnItem[j1] := { xValue,oNodeF:aItems[j1]:GetAttribute( "name" ) }
                  ENDIF
               NEXT
            ENDIF
         ENDIF
      ELSEIF oNodeF:title == "print_list"
         IF Empty( oNodeF:aItems )
            oDataTable:xPrnList := oNodeF:GetAttribute( "name" )
         ELSE
            IF oNodeF:aItems[1]:title == "script"
               oDataTable:xPrnList := HScript():New( oNodeF:aItems[1] )
            ELSE
               oDataTable:aPrnList := Array( Len( oNodeF:aItems ) )
               FOR j1 := 1 TO Len( oNodeF:aItems )
                  xValue := oNodeF:aItems[j1]:GetAttribute( "title" )
                  IF Empty( xValue )
                     xValue := oNodeF:aItems[j1]:GetAttribute( "name" )
                  ENDIF
                  IF !Empty(oNodeF:aItems[j1]:aItems) .AND. oNodeF:aItems[j1]:aItems[1]:title == "script"
                     oDataTable:aPrnList[j1] := { xValue,HScript():New( oNodeF:aItems[j1]:aItems[1] ) }
                  ELSE
                     oDataTable:aPrnList[j1] := { xValue,oNodeF:aItems[j1]:GetAttribute( "name" ) }
                  ENDIF
               NEXT
            ENDIF
         ENDIF
      ELSEIF oNodeF:title == "form"
         oDataTable:xForm := oNodeF:GetAttribute( "name" )
      ELSEIF oNodeF:title == "code_add"
         oDataTable:oRecAdd := HScript():New( oNodeF,"ADD" )
      ELSEIF oNodeF:title == "code_edi"
         oDataTable:oRecEdit := HScript():New( oNodeF,"EDI" )
      ELSEIF oNodeF:title == "code_del"
         oDataTable:oRecDel := HScript():New( oNodeF,"DEL" )
      ELSEIF oNodeF:title == "filters"
         oDataTable:filters := oNodeF:GetAttribute( "name" )
      ENDIF
   NEXT

   oDataTable:ext_id := ext_id
   oDataTable:cName := cName
   oDataTable:cPath := oNode:GetAttribute( "path" )
   IF oDataTable:cPath != Nil .AND. oApp:datalias != Nil .AND. ;
        ( j := At( "%", oDataTable:cPath ) ) != 0
      IF ( j1 := hb_At( "%", oDataTable:cPath, j+1 ) ) != 0
         cName := Lower( Substr( oDataTable:cPath, j+1, j1-j-1 ) )
         IF ( xValue := Ascan( oApp:datalias,{|a|Lower(a[1])==cName} ) ) != 0
            oDataTable:cPath := Stuff( oDataTable:cPath, j, j1-j+1, oApp:datalias[xValue,2] )
            IF Len(oApp:datalias[xValue]) > 2
               oDataTable:cDriver := oApp:datalias[xValue,3]
            ENDIF
            // hwg_Msginfo( cName + " " + oDataTable:cPath + " " + Iif(oDataTable:cDriver==Nil,"Nil",oDataTable:cDriver) )
         ENDIF
      ENDIF
      IF "%" $ oDataTable:cPath
         hwg_Msgstop( "??? " + oDataTable:cPath, oApp:cTitle )
      ENDIF
   ENDIF
   oDataTable:cAlias := cAlias
   IF ( cType := oNode:GetAttribute( "type" ) ) != Nil
      oDataTable:nType := Iif( cType=="no_open", 2, Iif( cType=="main",0,1 ) )
   ENDIF
   IF ( cType := oNode:GetAttribute( "codepage" ) ) != Nil
      oDataTable:cCP := Upper( cType )
   ENDIF
   IF ( cType := oNode:GetAttribute( "mode" ) ) != Nil .AND. Lower(cType) == "readonly"
      oDataTable:lWright := .F.
   ENDIF
   IF ( cType := oNode:GetAttribute( "title" ) ) != Nil
      oDataTable:cTitle := cType
   ENDIF

   IF oDataParent != Nil

      oDataTable:ext_id   := oDataParent:ext_id
      oDataTable:cPath    := oDataParent:cPath
      oDataTable:cDriver  := oDataParent:cDriver
      oDataTable:cCP      := oDataParent:cCP
      oDataTable:oRecAdd  := oDataParent:oRecAdd
      oDataTable:oRecEdit := oDataParent:oRecEdit
      oDataTable:oRecDel  := oDataParent:oRecDel

      IF oDataTable:aColumns == Nil
         oDataTable:aColumns := oDataParent:aColumns
      ENDIF
      IF oDataTable:ActiveTag == Nil
         oDataTable:ActiveTag := oDataParent:ActiveTag
      ENDIF
      IF oDataTable:xPrnItem == Nil
         oDataTable:xPrnItem := oDataParent:xPrnItem
      ENDIF
      IF oDataTable:aPrnItem == Nil
         oDataTable:aPrnItem := oDataParent:aPrnItem
      ENDIF
      IF oDataTable:xPrnList == Nil
         oDataTable:xPrnList := oDataParent:xPrnList
      ENDIF
      IF oDataTable:aPrnList == Nil
         oDataTable:aPrnList := oDataParent:aPrnList
      ENDIF
      IF oDataTable:xForm == Nil
         oDataTable:xForm := oDataParent:xForm
      ENDIF
      IF oDataTable:cAlias == Nil
         oDataTable:cAlias := oDataParent:cAlias
      ENDIF
      IF oDataTable:nType == Nil
         oDataTable:nType := oDataParent:nType
      ENDIF
      IF oDataTable:lWright == Nil
         oDataTable:lWright := oDataParent:lWright
      ENDIF
      IF oDataTable:cTitle == Nil
         oDataTable:cTitle := oDataParent:cTitle
      ENDIF
      IF oDataTable:filters == Nil
         oDataTable:filters := oDataParent:filters
      ENDIF
   ENDIF
   IF oDataTable:nType == Nil
      oDataTable:nType := 2
   ENDIF
   IF oDataTable:lWright == Nil
      oDataTable:lWright := .T.
   ENDIF

Return oDataTable

Static Function ReadOptions()
Local oOptions := HXMLDoc():Read( oApp:optPath+oApp:optName ), cp
Local i1, i, j, oSubs, oNode, oNodeT, cType, xValue

   IF Empty( oOptions:aItems ) .OR. oOptions:aItems[1]:title != "init"
      Return .F.
   ENDIF

   cp := Iif( "1251" $ (xValue:=oOptions:GetAttribute("encoding")), "RU1251", ;
            Iif( "koi" $ (xValue:=oOptions:GetAttribute("encoding")), "RUKOI8", "" ) )

   FOR i1 := 1 TO Len( oOptions:aItems[1]:aItems )
      oNode := oOptions:aItems[1]:aItems[i1]
      IF oNode:title == "subsystem"
         xValue := Iif( Empty(cp).OR.cp==oApp:cp,oNode:GetAttribute( "title" ), ;
                       hb_Translate( oNode:GetAttribute( "title" ),cp,oApp:cp ) )
         oSubs := HSubsys():New( xValue )
         IF ( xValue := oNode:GetAttribute("separate") ) != Nil ;
               .AND. Lower(xValue) == "true"
            oSubs:lMenuSep := .T.
         ENDIF
         FOR i := 1 TO Len( oNode:aItems )
            oNodeT := oNode:aItems[i]
            IF oNodeT:title == "table"
               Aadd( oSubs:aTables, ReadTbInfo( oNodeT,cp ) )
            ELSEIF oNodeT:title == "scrinit1"
               oSubs:oScrInit1 := HScript():New( oNodeT )
            ELSEIF oNodeT:title == "scrinit" .OR. oNodeT:title == "scrinit2"
               oSubs:oScrInit2 := HScript():New( oNodeT )
            ELSEIF oNodeT:title == "menuitem"
               xValue := Iif( Empty(cp).OR.cp==oApp:cp,oNodeT:GetAttribute( "title" ), ;
                             hb_Translate( oNodeT:GetAttribute( "title" ),cp,oApp:cp ) )
               AAdd( oSubs:aMenu, { xValue,HScript():New( oNodeT ) } )
            ELSEIF oNodeT:title == "toolbar"
               IF ( xValue := oNodeT:GetAttribute("mask") ) != Nil
                  oSubs:aToolMask := hwg_hfrm_Str2Arr( xValue )
               ENDIF
               FOR j := 1 TO Len( oNodeT:aItems )
                  Aadd( oSubs:aToolBtn, ReadBtnInfo(oNodeT:aItems[j]) )
               NEXT
            ENDIF
         NEXT
      ELSEIF oNode:title == "table"
         ReadTbInfo( oNode,cp )
      ELSEIF oNode:title == "const"
         xValue := oNode:GetAttribute("value")
         IF ( cType := oNode:GetAttribute("type") ) != Nil .AND. cType != "C"
            IF cType == "N"
               xValue := Val( xValue )
            ELSEIF cType == "D"
               xValue := Stod( xValue )
            ENDIF
         ELSE
            xValue := hb_Translate( xValue,cp,oApp:cp )
         ENDIF
         oApp:AddC( Lower( oNode:GetAttribute("name") ), xValue )
      ENDIF
   NEXT

Return .T.

Static Function ResizeBrw( oBrw, nWidth, nHeight )
Local aControls := (oBrw:oParent):aControls
Local aRect, i, nH1 := 0, nH2 := 0

   FOR i := 1 TO Len( aControls )
      IF aControls[i]:Classname() == "HPANEL"
         IF aControls[i]:nTop == 0
            nH1 += aControls[i]:nHeight
         ELSE
            nH2 += aControls[i]:nHeight
         ENDIF
      ELSEIF aControls[i]:Classname() == "HSTATUS"
         aRect := hwg_Getclientrect( aControls[i]:handle )
         nH2 += aRect[ 4 ]
      ENDIF
   NEXT
   oBrw:Move( , Iif(nH1==0,0,nH1+1), nWidth, nHeight-nH2-nH1-2 )
Return Nil

Static function About
Local oDlg, oFontB, oFontB2, oFontDlg, oFontSmall

   PREPARE FONT oFontDlg NAME "MS Sans Serif" WIDTH 0 HEIGHT -13
   PREPARE FONT oFontB NAME "MS Sans Serif" WIDTH 0 HEIGHT -13 WEIGHT 700
   PREPARE FONT oFontB2 NAME "MS Sans Serif" WIDTH 0 HEIGHT -18 WEIGHT 700
   PREPARE FONT oFontSmall NAME "MS Sans Serif" WIDTH 0 HEIGHT -11

   INIT DIALOG oDlg TITLE ""        ;
   AT 250,60  SIZE 400,200          ;
   FONT oFontDlg

   @ 15,10 BITMAP oApp:imgpath + "point.bmp"
   @ 160,20 SAY oApp:cAbout1          ;
        SIZE 220, 22 STYLE SS_CENTER  ;
        FONT oFontB2 COLOR hwg_VColor("FF0000")
   @ 160,42 SAY oApp:cAbout2          ;
        SIZE 220, 22 STYLE SS_CENTER  ;
        FONT oFontB2 COLOR hwg_VColor("FF0000")
   @ 160,70 SAY "Copyright 2006"  ;
        SIZE 220, 22 STYLE SS_CENTER
   @ 160,92 SAY " "  ;
        SIZE 220, 22 STYLE SS_CENTER FONT oFontB

   @ 160,116 LINE LENGTH 220
   @ 160,120 SAY HwG_Version(1)     ;
        SIZE 220, 26 STYLE SS_CENTER FONT oFontSmall

   @ 100,160 OWNERBUTTON ON CLICK {|| hwg_EndDialog()} ;
       SIZE 200,32 FLAT                            ;
       TEXT aTxt_Btn[9] COLOR hwg_VColor("0000FF") FONT oFontB

   ACTIVATE DIALOG oDlg

   oFontSmall:Release()
   oFontB2:Release()
   oFontB:Release()
   oFontDlg:Release()

Return Nil

Function WrDbLog( cId, cText )
Local cAlias := Alias()

   IF !Empty( oApp:cDbLog )
      USE (oApp:cDbLog) NEW SHARED
      APPEND BLANK
      REPLACE RDATE WITH Date(), RTIME WITH Time(), ID WITH cId, COMMENT WITH cText, ;
         USKOD WITH m->userCode
      dbCloseArea()
      IF !Empty( cAlias )
         dbSelectArea( cAlias )
      ENDIF
   ENDIF
Return Nil

Function Rec2Arr()
Local i, kolfld := FCOUNT()
Local aFields := Array( kolfld )

   FOR i := 1 TO kolfld
      aFields[i] := FieldGet( i )
   NEXT

Return aFields

Function Arr2Rec( aFields )
Local i, kolfld := FCOUNT()

   IF Rlock()
      FOR i := 1 TO kolfld
         IF !( aFields[i] == FieldGet( i ) )
            FieldPut( i,aFields[i] )
         ENDIF
      NEXT
      UNLOCK
   ELSE
      hwg_Msgstop( aTxt_Msg[22], oApp:cTitle )
      Return .F.
   ENDIF

Return .T.

Function FillVars( lEdit, cAlias )
Local i, kolfld, finame, aFields, cType, cPrefix

   IF cAlias == Nil
      cAlias := Alias()
      cPrefix := "m_"
   ELSE
      cPrefix := cAlias + "_"
   ENDIF

   kolfld := (cAlias)->( Fcount() )
   aFields := Array( kolfld )

   FOR i := 1 TO kolfld
      IF lEdit
         aFields[i] := (cAlias)->( FieldGet( i ) )
      ELSE
         cType := (cAlias)->( dbFieldInfo( DBS_TYPE,i ) )
         IF cType == "N"
            aFields[i] := (cAlias)->( Val( Str(0, dbFieldInfo(DBS_LEN,i), dbFieldInfo(DBS_DEC,i)) ) )
         ELSEIF cType == "D"
            aFields[i] := Ctod( Space(8) )
         ELSEIF cType == "L"
            aFields[i] := .F.
         ELSE
            aFields[i] := ""
         ENDIF
      ENDIF
      IF __mvExist( finame := cPrefix + (cAlias)->( dbFieldInfo( DBS_NAME,i ) ) )
         __mvPut( finame,aFields[i] )
      ENDIF
   NEXT

Return aFields

Function SaveVars( aFields, lNew, cAlias )
Local i, kolfld, lLocked := .F., finame, cPrefix

   IF !wright
      Return .F.
   ENDIF

   IF cAlias == Nil
      cAlias := Alias()
      cPrefix := "m_"
   ELSE
      cPrefix := cAlias + "_"
   ENDIF

   kolfld := (cAlias)->( Fcount() )

   FOR i := 1 TO kolfld
      IF __mvExist( finame := cPrefix + (cAlias)->( dbFieldInfo( DBS_NAME,i ) ) ) .AND. ;
                 !( __mvGet( finame ) == aFields[i] )
         IF !lLocked
            IF lNew
               (cAlias)->( dbAppend() )
            ELSE
               (cAlias)->( zpLock() )
            ENDIF
            lLocked := .T.
         ENDIF
         (cAlias)->( FieldPut( i, __mvGet( finame ) ) )
      ENDIF
   NEXT
   IF lLocked
      (cAlias)->( dbCommitAll() )
      (cAlias)->( dbUnlock() )
   ENDIF

Return .T.

FUNCTION CrLocateStr( aFields, cAlias )
Local strLocate := "", i, kolfld := Len( aFields ), cValue, cPrefix
Local cType, cName, finame, cAls

   IF cAlias == Nil
      cAls := Alias()
      cPrefix := "m_"
   ELSE
      cAls := cAlias
      cPrefix := cAls + "_"
   ENDIF

   FOR i := 1 TO kolfld
      IF __mvExist( finame := cPrefix + (cAls)->( dbFieldInfo( DBS_NAME,i ) ) ) .AND. ;
                 !( __mvGet( finame ) == aFields[i] )
         cValue := Rtrim( Transform( __mvGet( finame ), "@B" ) )
         cType := (cAls)->( dbFieldInfo( DBS_TYPE, i ) )
         finame := Iif( cAlias==Nil,"",cAlias+"->" ) + ;
               (cAls)->( dbFieldInfo( DBS_NAME,i ) )
         IF LEFT( cValue, 1 ) == '~'
            strLocate += Iif(Empty(strLocate),"",".AND.") + ;
                   '"' + Ltrim( SubStr( cValue,2 ) ) + ;
                   '" $ ' + finame
         ELSE
            IF cType == "C" .OR. cType == "D"
               cValue := '"'+cValue+'"'
            ELSEIF cType == "L"
               cValue := '.'+cValue+'.'
            ENDIF
            IF cType == "D"
               cName := "DTOC(" + finame + ")"
            ELSE
               cName := finame
            ENDIF
            strLocate += Iif(Empty(strLocate),"",".AND.") + ;
                             cName + '=' + cValue
         ENDIF
      ENDIF
   NEXT

Return strLocate

Function GetCondition( cCond )
Local oDlg, oFont := HFont():Add( "MS Sans Serif",0,-13 ), cRes := cCond

   INIT DIALOG oDlg TITLE aTxt_Msg[4] AT 0,0 SIZE 400,110 ;
        FONT oFont CLIPPER STYLE WS_POPUP+WS_VISIBLE+WS_CAPTION+WS_SYSMENU+DS_CENTER

   @ 15,16 GET cRes SIZE 370,24 STYLE ES_AUTOHSCROLL

   @ 20,70 BUTTON "Ok" ID IDOK SIZE 90,26
   @ 280,70 BUTTON "Cancel" ID IDCANCEL SIZE 90,26

   ACTIVATE DIALOG oDlg

   oFont:Release()
   IF oDlg:lResult
      Return Trim( cRes )
   ENDIF
Return cCond

Function GetRange( oGet,cCond )
Local oDlg, oFont := HFont():Add( "MS Sans Serif",0,-13 ), cRes := "", och3, och4
Local xValue1, xValue2, cType, cField := "", nPos, l1 := .T., l2 := .T., l3 := .F., l4 := .F.

   INIT DIALOG oDlg TITLE aTxt_Msg[5] AT 0,0 SIZE 400,160 ;
        FONT oFont CLIPPER STYLE WS_POPUP+WS_VISIBLE+WS_CAPTION+WS_SYSMENU+DS_CENTER

   IF ( cType := oGet:cType ) == "N"
      xValue1 := xValue2 := 0
   ELSEIF cType == "D"
      xValue1 := xValue2 := Ctod( Space(8) )
   ELSE
      xValue1 := xValue2 := Space( 30 )
   ENDIF
   @ 15,16 SAY "" SIZE 24,24
   @ 40,16 GET xValue1 SIZE 140,24 STYLE ES_AUTOHSCROLL
   @ 200,16 GET CHECKBOX l1 CAPTION aTxt_Msg[6] SIZE 120,24

   @ 15,40 SAY "" SIZE 24,24
   @ 40,40 GET xValue2 SIZE 140,24 STYLE ES_AUTOHSCROLL
   @ 200,40 GET CHECKBOX l2 CAPTION aTxt_Msg[6] SIZE 120,24

   @ 40,70 GET CHECKBOX och3 VAR l3 CAPTION aTxt_Msg[25] SIZE 120,24 ON CLICK {||Iif(l3,(DisableAllGets(oDlg),och3:Enable()),EnableAllGets(oDlg)),.T.}
   @ 200,70 GET CHECKBOX och4 VAR l4 CAPTION aTxt_Msg[26] SIZE 120,24 ON CLICK {||Iif(l4,(DisableAllGets(oDlg),och4:Enable()),EnableAllGets(oDlg)),.T.}

   @ 20,122 BUTTON "Ok" ID IDOK SIZE 90,26
   @ 280,122 BUTTON "Cancel" ID IDCANCEL SIZE 90,26

   ACTIVATE DIALOG oDlg

   oFont:Release()
   IF oDlg:lResult
      IF Valtype(oGet:cargo)=="C" .AND. ( nPos := At( "_", oGet:cargo ) ) != 0       
         cField := Iif( nPos==2, Substr(oGet:cargo,3), Left(oGet:cargo,nPos-1)+"->"+Substr(oGet:cargo,nPos+1) )
      ENDIF
      IF l3 .OR. l4
         cRes := Iif(l4,"!","")+"Empty("+cField+")"
         cCond := Iif( Empty(cCond), cRes, "("+cCond+").and.("+cRes+")" )
      ELSE
         IF !Empty( cField )
            IF !Empty( xValue1 )
               cRes := Iif( cType=="D", "DTOS("+cField+")",cField ) + ;
                  Iif( l1, ">=",">" ) + ;
                  Iif( cType=="D",'"'+DTOS(xValue1)+'"', ;
                     Iif( cType=="N",Ltrim(Str(xValue1)), xValue1 ) )
            ENDIF
            IF !Empty( xValue2 )
               cRes += Iif( !Empty(cRes),".and.","" ) + ;
                  Iif( cType=="D", "DTOS("+cField+")",cField ) + ;
                  Iif( l2, "<=","<" ) + ;
                  Iif( cType=="D",'"'+DTOS(xValue2)+'"', ;
                     Iif( cType=="N",Ltrim(Str(xValue2)), xValue2 ) )
            ENDIF
            cCond := Iif( Empty(cCond), cRes, "("+cCond+").and.("+cRes+")" )
         ENDIF
      ENDIF
   ENDIF
Return cCond

Static Function FltShb( oData )
Local cCond := "", arr := {}, nChoic, cDriver

   IF oData:filters == Nil
      Return cCond
   ENDIF
   cDriver := oApp:cDefDriver
   IF ::cDriver != Nil
      cDriver := ::cDriver
   ENDIF

#ifdef RDD_ADS
   IF cDriver != Nil .AND. cDriver == "ADS"
      IF oData:cCP == "RU866"
         SET CHARTYPE TO OEM
      ELSE
         SET CHARTYPE TO ANSI
      ENDIF
   ENDIF
#endif
   dbUseArea( .T.,cDriver, oData:cPath+oData:filters,, .T., .T., oData:cCP )
   nChoic := hwg_WChoice( "NAIM",aTxt_Msg[16],,,,,15132390,,hwg_VColor("008000"),"","" )
   dbCloseArea()

Return cCond

Static Function WrStatus( oData, cText, nPart )
Local aControls, i

   IF oData == Nil
      oData := oApp:oDataMain
   ENDIF
   IF oData:oBrowse != Nil
      aControls := oData:oBrowse:oParent:aControls
      FOR i := 1 TO Len( aControls )
         IF aControls[i]:Classname() == "HSTATUS"
#ifndef __LINUX__
            hwg_WriteStatus( oData:oBrowse:oParent, nPart , cText )
#endif
         ENDIF
      NEXT
   ENDIF
Return Nil
/*
Function RunScript( fname, scrname, args )
Local scr

   scr := OpenScript( oApp:optPath+fname, scrname )
Return DoScript( scr, args )
*/
/* --- CLASS HApp --- */

CLASS HApp

   DATA cTitle
   DATA cp
   DATA oMainWnd, oPanel, oBrw
   DATA optPath, optType, optName, imgpath, datalias
   DATA cDefDriver
   DATA cConnect
   DATA cDbLog
   DATA bClr, tClr, bClrSel, tClrSel
   DATA cAbout1, cAbout2
   DATA cPrinter, lPreview
   DATA oDataMain
   DATA oSubs
   DATA aConst    INIT {}
   DATA aVars     INIT {}

   METHOD New   INLINE Self
   METHOD GetC( cName )
   METHOD AddC( cName,xValue )
   METHOD GetV( cName )
   METHOD SetV( cName,xValue )
ENDCLASS

METHOD GetC( cName ) CLASS HApp
Local i

   cName := Lower( cName )
   IF ( i := Ascan( ::aConst,{|a|a[1]==cName} ) ) == 0
      Return Nil
   ENDIF
Return ::aConst[ i,2 ]

METHOD AddC( cName,xValue ) CLASS HApp

   Aadd( ::aConst, { cName,xValue } )
Return Nil

METHOD GetV( cName ) CLASS HApp
Local i

   cName := Lower( cName )
   IF ( i := Ascan( ::aVars,{|a|a[1]==cName} ) ) == 0
      Return Nil
   ENDIF
Return ::aVars[ i,2 ]

METHOD SetV( cName,xValue ) CLASS HApp
Local i

   cName := Lower( cName )
   IF ( i := Ascan( ::aVars,{|a|a[1]==cName} ) ) != 0
      ::aVars[ i,2 ] := xValue
   ELSE
      Aadd( ::aVars, { cName,xValue } )
   ENDIF
Return Nil


/* --- End of Class HApp --- */

/* --- CLASS HScript --- */

CLASS HScript

   DATA cFile
   DATA cName
   DATA xScript

   METHOD New( oNode, cNameDef )
   METHOD Run( aParam )
ENDCLASS

METHOD New( oNode, cNameDef ) CLASS HScript

   ::cFile := oNode:GetAttribute( "scrfile" )
   IF ::cFile == Nil .AND. !Empty( oNode:aItems ) .AND. oNode:aItems[1]:type == HBXML_TYPE_CDATA
      ::xScript := RdScript( , oNode:aItems[1]:aItems[1] )
   ELSEIF ( ::cName := oNode:GetAttribute( "scrname" ) ) == Nil
      ::cName := cNameDef
   ENDIF
Return Self

METHOD Run( aParam ) CLASS HScript

   IF ::xScript == Nil
      IF ( ::xScript := OpenScript( oApp:optPath + ::cFile, ::cName ) ) == Nil
         hwg_Msgstop( aTxt_Msg[20], oApp:cTitle )
         Return Nil
      ENDIF
   ENDIF 

Return DoScript( ::xScript, aParam )

/* --- End of Class HScript --- */

/* --- CLASS HSubsys --- */

CLASS HSubsys

   CLASS VAR aSubs   SHARED INIT {}
   DATA cTitle, nn
   DATA aTables   INIT {}
   DATA oScrInit1, oScrInit2
   DATA aMenu     INIT {}
   DATA aToolMask
   DATA aToolBtn  INIT {}
   DATA lMenuSep  INIT .F.        //      

   METHOD New( cTitle )
   METHOD GetTable( cName,cAlias )
   METHOD Open( cName )
   METHOD Close( cName )
   METHOD Run()
   METHOD SetDataMain( oData )
ENDCLASS

METHOD New( cTitle ) CLASS HSubsys

   ::cTitle := cTitle
   Aadd( ::aSubs, Self )
   ::nn := Len( ::aSubs )
Return Self

METHOD GetTable( cName,cAlias ) CLASS HSubsys
Local i := 0

   IF cName != Nil
      cName := Lower( cName )
      IF Empty( FilExten( cName ) )
         cName += ".dbf"
      ENDIF
   ENDIF
   IF cAlias != Nil
      cAlias := Upper( cAlias )
   ENDIF
   IF cName != Nil .AND. cAlias != Nil
      i := Ascan( ::aTables, {|o|o:cName==cName.and.o:cAlias==cAlias} )
   ELSEIF cName != Nil
      i := Ascan( ::aTables, {|o|o:cName==cName} )
   ELSEIF cAlias != Nil
      i := Ascan( ::aTables, {|o|o:cAlias==cAlias} )
   ENDIF
Return Iif( i == 0, Nil, ::aTables[i] )

METHOD Open( cName,cAlias,lShared ) CLASS HSubsys
Local oData

   IF ( oData := ::GetTable( cName,cAlias ) ) != Nil
      IF oData:lOpened
         dbSelectArea( oData:cAlias )
      ELSEIF !oData:Open(lShared)
         Return Nil
      ENDIF
      Return oData
   ENDIF
Return Nil

METHOD Close( cName ) CLASS HSubsys
Local oData

   IF ( oData := ::GetTable( cName ) ) != Nil .AND. oData:lOpened
      oData:Close()
   ENDIF
Return Nil

METHOD Run() CLASS HSubsys
Local aScr, i, aMenu, lRes

   IF oApp:oSubs != Nil

      IF oApp:oSubs == Self
         Return Nil
      ENDIF
      IF oApp:oBrw != Nil
         oApp:oMainWnd:DelControl( oApp:oBrw )
      ENDIF
      CLOSE ALL
      hwg_Checkmenuitem( ,31020+oApp:oSubs:nn, .F. )
#ifndef __LINUX__         
      FOR i := 1 TO Len( oApp:oSubs:aMenu )
         hwg_DeleteMenuItem( oApp:oMainWnd, 31050+i )
      NEXT
#endif
   ENDIF

   oApp:oDataMain := Nil
   oApp:oSubs := Self
   IF ::oScrInit1 != Nil
      lRes := ::oScrInit1:Run()
      IF Valtype( lRes ) == "L" .AND. !lRes
         oApp:oSubs := Nil
         Return Nil
      ENDIF
   ENDIF
   hwg_Checkmenuitem( ,31020+oApp:oSubs:nn, .T. )
   SetToolBar()
   
   FOR i := Len( ::aTables ) TO 1 STEP -1
      IF ::aTables[i]:nType < 2
         ::aTables[i]:Open()
         IF ::aTables[i]:nType == 0
            oApp:oDataMain := ::aTables[i]
         ENDIF
      ENDIF
   NEXT
   IF oApp:oDataMain == Nil
      SetEnable( .F. )
   ELSE
      dbSelectArea( oApp:oDataMain:cAlias )     
      oApp:oBrw := oApp:oDataMain:Browse( oApp:oMainWnd )
      oApp:oBrw:bEnter := {||oApp:oDataMain:EdDoc( DO_EDITREC )}
      oApp:oBrw:Refresh()
      SetEnable( .T. )
   ENDIF

#ifndef __LINUX__
   hwg_WriteStatus( oApp:oMainWnd, 1 , ::cTitle )
#endif

   aMenu := oApp:oMainWnd:menu[1,3]
   FOR i := 1 TO Len( oApp:oSubs:aMenu )
      Hwg_AddMenuItem( aMenu, oApp:oSubs:aMenu[i,1], 31050+i, .F., ;
              &( "{||oApp:oSubs:aMenu["+Ltrim(Str(i))+",2]:Run()}" ) )
   NEXT

   IF ::oScrInit2 != Nil
      ::oScrInit2:Run()
   ENDIF

   // hwg_Writelog( m->compName + ": Subsystem " + ::cTitle + " " + Time(),"general.log" )
   IF oApp:oBrw != Nil
      oApp:oBrw:SetFocus()
   ENDIF

Return Nil

METHOD SetDataMain( oData ) CLASS HSubsys
Local lDataMain := ( oApp:oDataMain != Nil )

   IF oApp:oBrw != Nil
      oApp:oMainWnd:DelControl( oApp:oBrw )
   ENDIF

   oData:Open()
   oApp:oDataMain := oData
   oApp:oBrw := oApp:oDataMain:Browse( oApp:oMainWnd )
   oApp:oBrw:bEnter := {||oApp:oDataMain:EdDoc( DO_EDITREC )}
   oApp:oBrw:Refresh()
   IF !lDataMain
      SetEnable( .T. )
   ENDIF

Return Nil

/* --- End of Class HSubsys --- */

/* --- CLASS HData --- */

CLASS HData
   CLASS VAR aTables   SHARED INIT {}
   DATA ext_id
   DATA cName, cPath, cAlias
   DATA cDriver
   DATA nType
   DATA cTitle  INIT ""
   DATA cCP     INIT "RU866"
   DATA lWright INIT .T.
   DATA lOpened INIT .F.
   DATA ActiveTag
   DATA oBrowse
   DATA aColumns
   DATA xPrnItem, abPrnItem, aPrnItem
   DATA xPrnList, abPrnList, aPrnList
   DATA xForm
   DATA oRecAdd
   DATA oRecEdit
   DATA oRecDel
   DATA filters
   DATA cargo

   METHOD New()
   METHOD Open( lShared )
   METHOD Close()
   METHOD Browse( oWindow )
   METHOD Eddoc( nTypeOp )
   METHOD Deldoc()
   METHOD Print( cPrinterName, lPreview, lList )
   METHOD CheckAdd()
   METHOD CheckEdit()
   METHOD CheckDel()
   METHOD Next()
   METHOD Prev()
ENDCLASS

METHOD New() CLASS HData
   Aadd( ::aTables, Self )
Return Self

METHOD Open( lShared ) CLASS HData
Local bOldError, cDriver

   IF lShared==Nil; lShared := .T.; ENDIF
   IF !( Right( ::cPath,1 ) $ "\/" )
      ::cPath += Set( _SET_DIRSEPARATOR )
   ENDIF
   IF ::cAlias == Nil
      ::cAlias := CutExten( ::cName )
   ENDIF
   ::cAlias := Upper( ::cAlias )

   cDriver := oApp:cDefDriver
   IF ::cDriver != Nil
      cDriver := ::cDriver
   ENDIF

#ifdef RDD_ADS
#ifdef __LINUX__
   IF oApp:cConnect != Nil
      adsConnect60( oApp:cConnect, ADS_AIS_SERVER )
      oApp:cConnect := Nil
   ENDIF
#else
   IF cDriver != Nil .AND. cDriver == "ADS"
      // hwg_Msginfo(::cCP)
      IF ::cCP == "RU866"
         SET CHARTYPE TO OEM
      ELSE
         SET CHARTYPE TO ANSI
      ENDIF
   ENDIF
#endif
#endif
   // hwg_Msginfo( ::cPath+::cName + "   " + cDriver + "   " + Iif(::cDriver==Nil,"Nil",::cDriver) )
   bOldError := ERRORBLOCK( {|e|ErrorFunc(e)} )
   BEGIN SEQUENCE
   dbUseArea( .T., cDriver, ::cPath+Cutexten(::cName), ::cAlias, lShared, !::lWright, ::cCP )
   RECOVER USING oError
      hwg_Msgstop( aTxt_Msg[21]+::cPath+Cutexten(::cName)+" ("+Ltrim(Str(oError:genCode))+")", oApp:cTitle )
      ERRORBLOCK( bOldError )
      Return .F.
   END SEQUENCE
   ERRORBLOCK( bOldError )

   ::lOpened := .T.
   IF ::ActiveTag != Nil
      ordSetFocus( ::ActiveTag )
   ENDIF
Return .T.

METHOD Close() CLASS HData
Local cAlias := Alias()

   IF !( cAlias == ::cAlias )
      dbSelectArea( ::cAlias )
   ENDIF
   dbCloseArea()
   ::lOpened := .F.
   IF !Empty(cAlias) .AND. !( cAlias == ::cAlias )
      dbSelectArea( cAlias )
   ENDIF

Return .T.

METHOD Browse( oWindow ) CLASS HData
Local oBrwFont, i, lCreateWnd := .F., cOldArea := Alias()
Local oPanel, nChoic := 0, aCoors

   IF Empty( ::aColumns )
      hwg_Msgstop( aTxt_Msg[23] )
      Return Nil
   ENDIF
   PREPARE FONT oBrwFont NAME "Arial" WIDTH 0 HEIGHT 16 CHARSET 204

   IF oWindow == Nil
      lCreateWnd := .T.
      INIT DIALOG oWindow TITLE ::cTitle ;
           AT 0,0 SIZE 400,500           ;
           STYLE WS_POPUP+WS_VISIBLE+WS_CAPTION+WS_SYSMENU+WS_SIZEBOX+DS_CENTER ;
           ON INIT {||oWindow:Move( ,,,oWindow:nHeight+4)} ;
           ON EXIT {||::oBrowse:=Nil,.T.}
   ENDIF

   dbSelectArea( ::cAlias )
   @ 0,0 BROWSE ::oBrowse DATABASE OF oWindow ;
     ON SIZE {|o,x,y|ResizeBrw(o,x,y)}

   IF oApp:bClr != Nil; ::oBrowse:bcolor := oApp:bClr;  ENDIF
   IF oApp:bClrSel != Nil; ::oBrowse:bcolorSel := oApp:bClrSel;  ENDIF
   IF oApp:tClr != Nil; ::oBrowse:tcolor := oApp:tClr;  ENDIF
   IF oApp:tClrSel != Nil; ::oBrowse:tcolorSel := oApp:tClrSel;  ENDIF

   ::oBrowse:oFont  := oBrwFont

   FOR i := 1 TO Len( ::aColumns )
      ADD COLUMN ::aColumns[i,1] TO ::oBrowse HEADER ::aColumns[i,2] ;
          TYPE Iif( ::aColumns[i,3]==Nil,"C",::aColumns[i,3] )       ;
          LENGTH Iif( ::aColumns[i,4]==Nil,10,Val(::aColumns[i,4]) ) ;
          DEC Iif( ::aColumns[i,5]==Nil,0,Val(::aColumns[i,5]) )
      IF ::aColumns[i,6] != Nil
         ::oBrowse:aColumns[Len(::oBrowse:aColumns)]:nJusLin := Val(::aColumns[i,6])
      ENDIF
   NEXT

   IF !Empty( ordSetFocus() )
      ::oBrowse:bRcou := &( "{||" + ::oBrowse:alias + "->(ORDKEYCOUNT())}" )
      ::oBrowse:bRecnoLog := &( "{||" + ::oBrowse:alias + "->(ORDKEYNO())}" )
   ENDIF
   ::oBrowse:bScrollPos := {|o,n,lEof,nPos|hwg_VScrollPos(o,n,lEof,nPos)}

   IF lCreateWnd
      @ 0,oWindow:nHeight-26 PANEL oPanel SIZE oWindow:nWidth,26

      @ 0,3 OWNERBUTTON OF oPanel             ;
           ON CLICK {||::oBrowse:Top()}       ;
           SIZE 22,22 FLAT                    ;
           BITMAP "top.bmp"                   ;
           TRANSPARENT COLOR 12632256         ;
           TOOLTIP aTxt_Btn[1]
      @ 22,3 OWNERBUTTON OF oPanel            ;
           ON CLICK {||::oBrowse:Bottom()}    ;
           SIZE 22,22 FLAT                    ;
           BITMAP "bottom.bmp"                ;
           TRANSPARENT COLOR 12632256         ;
           TOOLTIP aTxt_Btn[2]

      @ 45,5 LINE OF oPanel LENGTH 18 VERTICAL

      IF ::lWright
         @ 48,3 OWNERBUTTON OF oPanel          ;
              ON CLICK {||::EdDoc( DO_ADDREC )};
              SIZE 22,22 FLAT                  ;
              BITMAP "add.bmp"                 ;
              TRANSPARENT COLOR 12632256       ;
              TOOLTIP aTxt_Btn[3]
      ENDIF
      @ 70,3 OWNERBUTTON OF oPanel           ;
           ON CLICK {||::EdDoc( DO_EDITREC )};
           SIZE 22,22 FLAT                   ;
           BITMAP "edit.bmp"                 ;
           TRANSPARENT COLOR 12632256        ;
           TOOLTIP aTxt_Btn[4]

      @ 95,5 LINE OF oPanel LENGTH 18 VERTICAL

      @ 98,3 OWNERBUTTON OF oPanel            ;
           ON CLICK {||::EdDoc( DO_FINDREC )} ;
           SIZE 22,22 FLAT                    ;
           BITMAP "find.bmp"                  ;
           TRANSPARENT COLOR 12632256         ;
           TOOLTIP aTxt_Btn[5]
      @ 120,3 OWNERBUTTON OF oPanel           ;
           ON CLICK {||::EdDoc( DO_FILTREC )} ;
           SIZE 22,22 FLAT                    ;
           BITMAP "filter.bmp"                ;
           TRANSPARENT COLOR 12632256         ;
           TOOLTIP aTxt_Btn[6]

      @ 145,5 LINE OF oPanel LENGTH 18 VERTICAL

      @ 148,3 OWNERBUTTON OF oPanel           ;
           ON CLICK {||nChoic:=(::cAlias)->(Recno()),hwg_EndDialog()};
           SIZE 22,22 FLAT                    ;
           BITMAP "select.bmp"                ;
           TRANSPARENT COLOR 12632256         ;
           TOOLTIP aTxt_Btn[10]

      IF ::lWright
         hwg_SetDlgKey( oWindow,0,VK_F3,{||::EdDoc(DO_ADDREC)} )
      ENDIF
      hwg_SetDlgKey( oWindow,0,VK_F5,{||::EdDoc(DO_FINDREC)} )
      hwg_SetDlgKey( oWindow,0,VK_F6,{||::EdDoc(DO_FILTREC)} )

      ACTIVATE DIALOG oWindow
   ELSE
      aCoors := hwg_Getclientrect( oWindow:handle )
      ResizeBrw( ::oBrowse, aCoors[3], aCoors[4] )
   ENDIF
   dbSelectArea( cOldArea )

Return Iif( lCreateWnd, nChoic, ::oBrowse )

METHOD Eddoc( nTypeOp ) CLASS HData
Local xResult, stusl, stseek

   dbSelectArea( ::cAlias )
   IF ::xForm == Nil
      hwg_Msgstop( aTxt_Msg[8],oApp:cTitle )
   ELSEIF Valtype( ::xForm ) == "C"
      ::xForm := OpenFrx( oApp:optPath + ::xForm )
   ENDIF
   IF ::xForm == Nil
      Return .F.
   ENDIF

   xResult := ::xForm:Show( ,Self,nTypeOp )
   IF nTypeOp == DO_FINDREC
      IF !Empty( xResult )
         WrStatus( Self, aTxt_Msg[9], 2 )
         LOCATE FOR &xResult
         WrStatus( Self, Iif(Found(),aTxt_Msg[10],aTxt_Msg[11]), 2 )
      ENDIF
   ELSEIF nTypeOp == DO_FILTREC
      IF Empty( xResult )
         DestroyFlt( ::oBrowse )
         IF !Empty( ordSetFocus() )
            ::oBrowse:bRcou := &( "{||" + ::oBrowse:alias + "->(ORDKEYCOUNT())}" )
            ::oBrowse:bRecnoLog := &( "{||" + ::oBrowse:alias + "->(ORDKEYNO())}" )
         ENDIF
         WrStatus( Self, "", 2 )
      ELSE
         SpeedFlt( xResult, @stusl, @stseek )
         CreateFlt( ::oBrowse, stseek, stusl, xResult )
         ::oBrowse:Top()
         WrStatus( Self, Iif(::oBrowse:nRecords>0,aTxt_Msg[12]+Ltrim(Str(::oBrowse:nRecords)),aTxt_Msg[13]), 2 )
      ENDIF
   ENDIF
   IF ::oBrowse != Nil
      ::oBrowse:Refresh()
      ::oBrowse:SetFocus()
   ENDIF

Return .T.

METHOD Deldoc() CLASS HData

   dbSelectArea( ::cAlias )
   IF ::CheckDel()
      zpLock()
      dbDelete()
      COMMIT
      UNLOCK
      ::Next()
      IF ::oBrowse != Nil
         ::oBrowse:Refresh()
      ENDIF
   ENDIF
Return .F.

METHOD Print( cPrinterName, lPreview, lList, xParam1, xParam2 ) CLASS HData
Local xPrn, abPrn, aPrn, i

   dbSelectArea( ::cAlias )
   IF lList == Nil .OR. !lList
      xPrn :=  ::xPrnItem
      abPrn := ::abPrnItem
      aPrn :=  ::aPrnItem
   ELSE
      xPrn := ::xPrnList
      abPrn := ::abPrnList
      aPrn :=  ::aPrnList
   ENDIF

   IF aPrn == Nil .AND. xPrn == Nil
      hwg_Msgstop( aTxt_Msg[14], oApp:cTitle )
      Return .F.
   ELSEIF aPrn != Nil
      IF ( i := hwg_WChoice( aPrn,aTxt_Msg[15],,,,,,,,aTxt_Msg[16] ) ) == 0
         Return .F.
      ELSEIF xPrn == Nil .OR. !( Valtype(xPrn) == Valtype(aPrn[i,2]) ) .OR. !( xPrn == aPrn[i,2] )
         xPrn  := aPrn[i,2]
         IF Valtype( xPrn ) == "O"
            xPrn:Run()
            Return .T.
         ENDIF
         abPrn := OpenRpx( oApp:optPath + xPrn )
      ENDIF
   ELSEIF Valtype( xPrn ) == "O"
      xPrn:Run()
      Return .T.
   ELSEIF abPrn == Nil
      abPrn := OpenRpx( oApp:optPath + xPrn )
   ENDIF

   IF abPrn != Nil
      abPrn:Print( cPrinterName, lPreview, Self, xParam1, xParam2 )
   ELSE
      hwg_Msgstop( aTxt_Msg[17], oApp:cTitle )
      Return .F.
   ENDIF

   IF Valtype( xPrn ) == "C"
      IF lList == Nil .OR. !lList
         ::abPrnItem := abPrn
      ELSE
         ::xPrnList  := xPrn
         ::abPrnList := abPrn
      ENDIF
   ENDIF

Return .T.

METHOD CheckAdd() CLASS HData

   dbSelectArea( ::cAlias )
   IF ::oRecAdd == Nil
      Return .T.
   ENDIF
Return ::oRecAdd:Run()

METHOD CheckEdit() CLASS HData

   dbSelectArea( ::cAlias )
   IF ::oRecEdit == Nil
      Return .T.
   ENDIF
Return ::oRecEdit:Run()

METHOD CheckDel() CLASS HData

   dbSelectArea( ::cAlias )
   IF ::oRecDel == Nil
      Return .T.
   ENDIF
Return ::oRecDel:Run()

METHOD Next() CLASS HData
Local cMsgEof := aTxt_Msg[18], nRec, res := .T.

   dbSelectArea( ::cAlias )
   IF ::oBrowse == Nil
      dbSkip( 1 )
      IF Eof()
         dbSkip( -1 )
         res := .F.
      ENDIF
   ELSE
      nRec := Recno()
      ::oBrowse:LineDown()
      IF nRec == Recno()        
         res := .F.
      ENDIF
   ENDIF
   IF !res
      hwg_Msginfo( cMsgEof,oApp:cTitle )
   ENDIF

Return res

METHOD Prev() CLASS HData
Local cMsgBof := aTxt_Msg[19], nRec, res := .T.

   dbSelectArea( ::cAlias )
   nRec := Recno() 
   IF ::oBrowse == Nil
      dbSkip( -1 )
   ELSE     
      ::oBrowse:LineUp()
   ENDIF
   IF nRec == Recno()
      hwg_Msginfo( cMsgBof,oApp:cTitle )
      res := .F.
   ENDIF

Return res

/* --- End of Class HData --- */

STATIC FUNCTION ErrorFunc( e )
   BREAK e
RETURN

FUNCTION OpenFrx( fname,cId )
#ifdef __LINUX__
Local i, cp

   IF oApp:cp == "RUKOI8"
      IF !Empty( fname := MemoRead( fname ) )
         IF ( i := At("encoding=",fname) ) != 0
            IF Substr( fname, i+10,3 ) == "win"
               RETURN HFormTmpl():Read( hb_Translate( fname,"RU1251",oApp:cp ),cId )
            ENDIF
         ENDIF
      ENDIF
   ENDIF
#endif
RETURN HFormTmpl():Read( fname,cId )

FUNCTION OpenRpx( fname,cId )
#ifdef __LINUX__
Local i, cp

   IF oApp:cp == "RUKOI8"
      IF !Empty( fname := MemoRead( fname ) )
         IF ( i := At("encoding=",fname) ) != 0
            IF Substr( fname, i+10,3 ) == "win"
               RETURN HRepTmpl():Read( hb_Translate( fname,"RU1251",oApp:cp ),cId )
            ENDIF
         ENDIF
      ENDIF
   ENDIF
#endif
RETURN HRepTmpl():Read( fname,cId )

STATIC FUNCTION EnableAllGets( oDlg )

   AEval( oDlg:GetList, {|o|o:Enable()} )
RETURN

STATIC FUNCTION DisableAllGets( oDlg )

   AEval( oDlg:GetList, {|o|o:Disable()} )
RETURN

FUNCTION gBrowse( arr, cTitle )
Local oWindow, oBrw, oBrwFont, i
Local oPanel, nChoic := 0, aCoors

   PREPARE FONT oBrwFont NAME "MS Sans Serif" WIDTH 0 HEIGHT -13

   INIT DIALOG oWindow TITLE cTitle   ;
        AT 0,0 SIZE 400,500           ;
        STYLE WS_POPUP+WS_VISIBLE+WS_CAPTION+WS_SYSMENU+WS_SIZEBOX+DS_CENTER ;
        ON INIT {||oWindow:Move( ,,,oWindow:nHeight+4)}

   @ 0,0 BROWSE oBrw ARRAY OF oWindow ;
     ON SIZE {|o,x,y|ResizeBrw(o,x,y)}

   oBrw:aArray := arr
   oBrw:oFont  := oBrwFont
   oBrw:bEnter := {||nChoic:=oBrw:nCurrent,hwg_EndDialog()}

   IF oApp:bClr != Nil; oBrw:bcolor := oApp:bClr;  ENDIF
   IF oApp:bClrSel != Nil; oBrw:bcolorSel := oApp:bClrSel;  ENDIF
   IF oApp:tClr != Nil; oBrw:tcolor := oApp:tClr;  ENDIF
   IF oApp:tClrSel != Nil; oBrw:tcolorSel := oApp:tClrSel;  ENDIF

   IF Len( arr ) > 0 .AND. Valtype( arr[1] ) == "A"
      FOR i := 1 TO Len( arr[1] )
         oBrw:AddColumn( HColumn():New( ,hwg_ColumnArBlock(), Valtype(arr[1,i]), Iif(Valtype(arr[1,i])=="C",Len(arr[1,i]),4)) )
      NEXT
   ELSE
      oBrw:AddColumn( HColumn():New( ,{|value,o|o:aArray[o:nCurrent]},Valtype(arr[1]), Iif(Valtype(arr[1])=="C",Len(arr[1]),10)) )
   ENDIF

   oBrw:bScrollPos := {|o,n,lEof,nPos|hwg_VScrollPos(o,n,lEof,nPos)}

   @ 0,oWindow:nHeight-26 PANEL oPanel SIZE oWindow:nWidth,26

   @ 0,3 OWNERBUTTON OF oPanel             ;
        ON CLICK {||oBrw:Top()}       ;
        SIZE 22,22 FLAT                    ;
        BITMAP "top.bmp"                   ;
        TRANSPARENT COLOR 12632256
        // TOOLTIP aTxt_Btn[1]
   @ 22,3 OWNERBUTTON OF oPanel            ;
        ON CLICK {||oBrw:Bottom()}    ;
        SIZE 22,22 FLAT                    ;
        BITMAP "bottom.bmp"                ;
        TRANSPARENT COLOR 12632256
        // TOOLTIP aTxt_Btn[2]

   @ 45,5 LINE OF oPanel LENGTH 18 VERTICAL

   @ 148,3 OWNERBUTTON OF oPanel           ;
        ON CLICK oBrw:bEnter               ;
        SIZE 22,22 FLAT                    ;
        BITMAP "select.bmp"                ;
        TRANSPARENT COLOR 12632256         ;
        // TOOLTIP aTxt_Btn[10]

   ACTIVATE DIALOG oWindow

RETURN nChoic

Static Function ChangeFont( oCtrl, n )
Local oFont, nHeight := oCtrl:oFont:height, i, nOld

   nOld := nHeight
   nHeight := Iif( nHeight<0, nHeight-n, nHeight+n )
   oFont := HFont():Add( oCtrl:oFont:name, oCtrl:oFont:Width,nHeight,,oCtrl:oFont:Charset, )
   hwg_Setctrlfont( oCtrl:oParent:handle, oCtrl:id, ( oCtrl:oFont := oFont ):handle )
   IF __ObjHasMsg( oCtrl, "ACOLUMNS" )
      FOR i := 1 TO Len( oCtrl:aColumns )
         oCtrl:aColumns[i]:width := Int( oCtrl:aColumns[i]:width * (nHeight/nOld) )
      NEXT
      oCtrl:Refresh( .T. )
   ELSE
      hwg_Redrawwindow( oCtrl:handle, RDW_ERASE + RDW_INVALIDATE )
   ENDIF

   Return Nil

Function WrLog( cText )
LOCAL i, nHand

  cFile := "a.log"
   
  IF !File( cFile )           
     nHand := Fcreate( cFile )
  ELSE                                     
     nHand := Fopen( cFile,1)
  ENDIF
  IF Ferror() != 0                           
    hwg_Msgstop("a.log - error")  
     Return .F.
  ENDIF

  Fseek(nHand, 0,2 )
  Fwrite( nHand, "  "+ cText + Chr(13) + Chr(10) )
  Fclose( nHand )

Return .T.

Function _getLocalIP()
Local cIP := ""
#ifdef RDD_LETO
   cIp := leto_getLocalIP()
#endif
Return cIp
